<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/AVSCommon/AVS/include/AVSCommon/AVS/AVSDirective.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_13e65effb2bde530b17b3d5eefcd0266.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_80711c2a226d5fced33fce22558d3784.html">AVS</a></li><li class="navelem"><a class="el" href="dir_a8d3deb3c1282038af9ce4454694c1e1.html">include</a></li><li class="navelem"><a class="el" href="dir_4c314a0d19d1aa5c860795d42a926e2c.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_1b86ff6fe19386d1d992f6fa0aca02b2.html">AVS</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">AVSDirective.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_a_v_s_directive_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_AVSCOMMON_AVS_INCLUDE_AVSCOMMON_AVS_AVSDIRECTIVE_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_AVSCOMMON_AVS_INCLUDE_AVSCOMMON_AVS_AVSDIRECTIVE_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;utility&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_attachment_manager_interface_8h.html">Attachment/AttachmentManagerInterface.h</a>&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_v_s_message_8h.html">AVSMessage.h</a>&quot;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span>avsCommon {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span>avs {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">   34</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html">AVSMessage</a> {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">   39</a></span>&#160;    <span class="keyword">enum class</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">ParseStatus</a> {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aad0749aaba8b833466dfcbb0428e4f89c">SUCCESS</a>,</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa0cd012636a45bdff34a0a011c219f75f">ERROR_INVALID_JSON</a>,</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa4468ffaec2d10cfc0afc4875884b2428">ERROR_MISSING_DIRECTIVE_KEY</a>,</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa2928fbc5b71d4e4495c534d6d7428f98">ERROR_MISSING_HEADER_KEY</a>,</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa00080eacc84508834c95ee3a4208479d">ERROR_MISSING_NAMESPACE_KEY</a>,</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa40df3f73742319aee259a2097e988eeb">ERROR_MISSING_NAME_KEY</a>,</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aacd0d709786ee43c9798ba52689dde912">ERROR_MISSING_MESSAGE_ID_KEY</a>,</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aac29847d86d1e896be9adb2c271b1cba1">ERROR_MISSING_PAYLOAD_KEY</a></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    };</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">static</span> std::pair&lt;std::unique_ptr&lt;AVSDirective&gt;, <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">ParseStatus</a>&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a8e9e239c6457e43dd261dad01482be7e">create</a>(</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keyword">const</span> std::string&amp; unparsedDirective,</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentManagerInterface&gt; attachmentManager,</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keyword">const</span> std::string&amp; attachmentContextId);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keyword">static</span> std::unique_ptr&lt;AVSDirective&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a8e9e239c6457e43dd261dad01482be7e">create</a>(</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keyword">const</span> std::string&amp; unparsedDirective,</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        std::shared_ptr&lt;AVSMessageHeader&gt; avsMessageHeader,</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keyword">const</span> std::string&amp; payload,</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentManagerInterface&gt; attachmentManager,</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keyword">const</span> std::string&amp; attachmentContextId);</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    std::unique_ptr&lt;avsCommon::avs::attachment::AttachmentReader&gt; <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a4e4da298bd174e8fc41ba0a06d631cbd">getAttachmentReader</a>(</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keyword">const</span> std::string&amp; contentId,</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">utils::sds::ReaderPolicy</a> readerPolicy) <span class="keyword">const</span>;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    std::string <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#afb5210c45e69fb93b2c928f0451ae90c">getUnparsedDirective</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a>(</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        <span class="keyword">const</span> std::string&amp; unparsedDirective,</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        std::shared_ptr&lt;AVSMessageHeader&gt; avsMessageHeader,</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keyword">const</span> std::string&amp; payload,</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentManagerInterface&gt; attachmentManager,</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keyword">const</span> std::string&amp; attachmentContextId);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keyword">const</span> std::string m_unparsedDirective;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    std::shared_ptr&lt;avsCommon::avs::attachment::AttachmentManagerInterface&gt; m_attachmentManager;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    std::string m_attachmentContextId;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;};</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00143"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a745c354a33a805ad0a652d10aa36db9c">  143</a></span>&#160;<span class="keyword">inline</span> std::string <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a745c354a33a805ad0a652d10aa36db9c">avsDirectiveParseStatusToString</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">AVSDirective::ParseStatus</a> status) {</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">switch</span> (status) {</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aad0749aaba8b833466dfcbb0428e4f89c">AVSDirective::ParseStatus::SUCCESS</a>:</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;SUCCESS&quot;</span>;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa0cd012636a45bdff34a0a011c219f75f">AVSDirective::ParseStatus::ERROR_INVALID_JSON</a>:</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;ERROR_INVALID_JSON&quot;</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa4468ffaec2d10cfc0afc4875884b2428">AVSDirective::ParseStatus::ERROR_MISSING_DIRECTIVE_KEY</a>:</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;ERROR_MISSING_DIRECTIVE_KEY&quot;</span>;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa2928fbc5b71d4e4495c534d6d7428f98">AVSDirective::ParseStatus::ERROR_MISSING_HEADER_KEY</a>:</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;ERROR_MISSING_HEADER_KEY&quot;</span>;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa00080eacc84508834c95ee3a4208479d">AVSDirective::ParseStatus::ERROR_MISSING_NAMESPACE_KEY</a>:</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;ERROR_MISSING_NAMESPACE_KEY&quot;</span>;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa40df3f73742319aee259a2097e988eeb">AVSDirective::ParseStatus::ERROR_MISSING_NAME_KEY</a>:</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;ERROR_MISSING_NAME_KEY&quot;</span>;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aacd0d709786ee43c9798ba52689dde912">AVSDirective::ParseStatus::ERROR_MISSING_MESSAGE_ID_KEY</a>:</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;ERROR_MISSING_MESSAGE_ID_KEY&quot;</span>;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aac29847d86d1e896be9adb2c271b1cba1">AVSDirective::ParseStatus::ERROR_MISSING_PAYLOAD_KEY</a>:</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;ERROR_MISSING_PAYLOAD_KEY&quot;</span>;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    }</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="keywordflow">return</span> <span class="stringliteral">&quot;UNKNOWN_STATUS&quot;</span>;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;}</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno"><a class="line" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a7c03504af12853a6a16d7f525a0f906b">  172</a></span>&#160;<span class="keyword">inline</span> std::ostream&amp; <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a7c03504af12853a6a16d7f525a0f906b">operator&lt;&lt;</a>(std::ostream&amp; stream, <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">AVSDirective::ParseStatus</a>&amp; status) {</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordflow">return</span> stream &lt;&lt; <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a745c354a33a805ad0a652d10aa36db9c">avsDirectiveParseStatusToString</a>(status);</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;}</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;}  <span class="comment">// namespace avs</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;}  <span class="comment">// namespace avsCommon</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_AVSCOMMON_AVS_INCLUDE_AVSCOMMON_AVS_AVSDIRECTIVE_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_a4e4da298bd174e8fc41ba0a06d631cbd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a4e4da298bd174e8fc41ba0a06d631cbd">alexaClientSDK::avsCommon::avs::AVSDirective::getAttachmentReader</a></div><div class="ttdeci">std::unique_ptr&lt; avsCommon::avs::attachment::AttachmentReader &gt; getAttachmentReader(const std::string &amp;contentId, utils::sds::ReaderPolicy readerPolicy) const</div><div class="ttdef"><b>Definition:</b> AVSDirective.cpp:215</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aad0749aaba8b833466dfcbb0428e4f89c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aad0749aaba8b833466dfcbb0428e4f89c">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::SUCCESS</a></div><div class="ttdoc">The parse was successful. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html">alexaClientSDK::avsCommon::avs::AVSMessage</a></div><div class="ttdef"><b>Definition:</b> AVSMessage.h:32</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aa00080eacc84508834c95ee3a4208479d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa00080eacc84508834c95ee3a4208479d">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::ERROR_MISSING_NAMESPACE_KEY</a></div><div class="ttdoc">The parse failed due to the namespace key being missing. </div></div>
<div class="ttc" id="_a_v_s_message_8h_html"><div class="ttname"><a href="_a_v_s_message_8h.html">AVSMessage.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aacd0d709786ee43c9798ba52689dde912"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aacd0d709786ee43c9798ba52689dde912">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::ERROR_MISSING_MESSAGE_ID_KEY</a></div><div class="ttdoc">The parse failed due to the message id key being missing. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_a8e9e239c6457e43dd261dad01482be7e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a8e9e239c6457e43dd261dad01482be7e">alexaClientSDK::avsCommon::avs::AVSDirective::create</a></div><div class="ttdeci">static std::pair&lt; std::unique_ptr&lt; AVSDirective &gt;, ParseStatus &gt; create(const std::string &amp;unparsedDirective, std::shared_ptr&lt; avsCommon::avs::attachment::AttachmentManagerInterface &gt; attachmentManager, const std::string &amp;attachmentContextId)</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_afb5210c45e69fb93b2c928f0451ae90c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#afb5210c45e69fb93b2c928f0451ae90c">alexaClientSDK::avsCommon::avs::AVSDirective::getUnparsedDirective</a></div><div class="ttdeci">std::string getUnparsedDirective() const</div><div class="ttdef"><b>Definition:</b> AVSDirective.cpp:234</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aa4468ffaec2d10cfc0afc4875884b2428"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa4468ffaec2d10cfc0afc4875884b2428">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::ERROR_MISSING_DIRECTIVE_KEY</a></div><div class="ttdoc">The parse failed due to the directive key being missing. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">alexaClientSDK::avsCommon::avs::AVSDirective</a></div><div class="ttdef"><b>Definition:</b> AVSDirective.h:34</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000a"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus</a></div><div class="ttdeci">ParseStatus</div><div class="ttdef"><b>Definition:</b> AVSDirective.h:39</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a745c354a33a805ad0a652d10aa36db9c"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a745c354a33a805ad0a652d10aa36db9c">alexaClientSDK::avsCommon::avs::avsDirectiveParseStatusToString</a></div><div class="ttdeci">std::string avsDirectiveParseStatusToString(AVSDirective::ParseStatus status)</div><div class="ttdef"><b>Definition:</b> AVSDirective.h:143</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_html_a07d2a9441f40d089a1f9a0d7e2baab4b"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">alexaClientSDK::avsCommon::utils::sds::ReaderPolicy</a></div><div class="ttdeci">ReaderPolicy</div><div class="ttdoc">Specifies the policy to use for reading from the stream. </div><div class="ttdef"><b>Definition:</b> ReaderPolicy.h:25</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a7c03504af12853a6a16d7f525a0f906b"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a7c03504af12853a6a16d7f525a0f906b">alexaClientSDK::avsCommon::avs::operator&lt;&lt;</a></div><div class="ttdeci">std::ostream &amp; operator&lt;&lt;(std::ostream &amp;stream, const AVSDirective::ParseStatus &amp;status)</div><div class="ttdef"><b>Definition:</b> AVSDirective.h:172</div></div>
<div class="ttc" id="_attachment_manager_interface_8h_html"><div class="ttname"><a href="_attachment_manager_interface_8h.html">AttachmentManagerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aa2928fbc5b71d4e4495c534d6d7428f98"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa2928fbc5b71d4e4495c534d6d7428f98">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::ERROR_MISSING_HEADER_KEY</a></div><div class="ttdoc">The parse failed due to the header key being missing. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aa0cd012636a45bdff34a0a011c219f75f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa0cd012636a45bdff34a0a011c219f75f">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::ERROR_INVALID_JSON</a></div><div class="ttdoc">The parse failed due to invalid JSON formatting. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aa40df3f73742319aee259a2097e988eeb"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa40df3f73742319aee259a2097e988eeb">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::ERROR_MISSING_NAME_KEY</a></div><div class="ttdoc">The parse failed due to the name key being missing. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_html_aec5d27fc4922b753ff8952280d54000aac29847d86d1e896be9adb2c271b1cba1"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aac29847d86d1e896be9adb2c271b1cba1">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus::ERROR_MISSING_PAYLOAD_KEY</a></div><div class="ttdoc">The parse failed due to the message payload key being missing. </div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
